;;; Examples for Problem Set 00.
;;;
;;; Students should write their own examples for complete glass-box
;;; testing of their implementations.
;;;
;;; The examples used for grading will not be exactly the same as
;;; these examples.

(define-library (module-examples)

  (export foo
          circularModules
          modules1
          modules2)

  (import (scheme base)
          (module))

  (begin

   ;; a description of a module that's been modified since it was compiled
   ;; and must therefore be compiled again before it is used

   (define foo
     (makeModule "Foo" '("Baz") 1505109465 1504097449 "LP64"))

   ;; a list of modules that have a circular dependency

   (define circularModules
     (list (makeModule "M1" '("M2" "M3") 1500 -1 "ILP32")
           (makeModule "M2" '("M3")      2000 -1 "ILP32")
           (makeModule "M3" '("M2")      2500 -1 "ILP32")))

   ;; a list of modules, of which only Main needs to be compiled
   ;; (in mode LP64) before Main can be used

   (define modules1
     (list
      (makeModule "Main"  '("List" "AList") 1504188920 -1         "LP64")
      (makeModule "List"  '("Obj")          1472652920 1472658760 "LP64")
      (makeModule "AList" '("List" "Obj")   1472654764 1472659242 "LP64")
      (makeModule "Obj"   '()               1472630256 1472638841 "LP64")))

   ;; a list of modules, of which List, AList, and Main need to be compiled
   ;; (in that order, in mode ILP32) before Main can be used

   (define modules2
     (list
      (makeModule "Main"  '("List" "AList") 1504188920 -1         "LP64")
      (makeModule "List"  '("Obj")          1472652920 1472658760 "LP64")
      (makeModule "AList" '("List" "Obj")   1472654764 1472659242 "LP64")
      (makeModule "Obj"   '()               1472630256 1472638841 "ILP32")))

   ))
